/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package my.joes;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.Toolkit;
import java.awt.geom.GeneralPath;
import java.io.IOException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.File;
import javax.swing.JFileChooser;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import static java.lang.Math.exp;
import static java.lang.Math.log;
import static java.lang.Math.pow;
import static java.lang.Math.sqrt;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import java.awt.Image;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import static jdk.nashorn.internal.objects.NativeMath.round;
import java.text.DecimalFormat;

/**
 *
 * @author Aleksandar Ciric: aleksandarciric83@gmail.com The software is under
 * GPLv3 license Made for University of Belgrade and Physics Research Institute,
 * Vinca
 */
class PPanel extends JPanel {

    public void brisi() {
        super.paintComponent(this.getGraphics());
    }
}

class txtFilter extends javax.swing.filechooser.FileFilter {

    @Override
    public boolean accept(File file) {
        // Allow only directories, or files with ".joes" extension
        return file.isDirectory() || file.getAbsolutePath().endsWith(".txt");
    }

    @Override
    public String getDescription() {
        // This description will be displayed in the dialog,
        // hard-coded = ugly, should be done via I18N
        return "Input file (*.txt)";
    }
}

class joesFilter extends javax.swing.filechooser.FileFilter {

    @Override
    public boolean accept(File file) {
        // Allow only directories, or files with ".joes" extension
        return file.isDirectory() || file.getAbsolutePath().endsWith(".joes");
    }

    @Override
    public String getDescription() {
        // This description will be displayed in the dialog,
        // hard-coded = ugly, should be done via I18N
        return "Configuration file (*.joes)";
    }
}

public class JOES_UI extends javax.swing.JFrame {

    int m = 0; //number of x and y values
    double[] A = {0, 0, 0, 0}; //Areas of MD and 3 important ED, in cm
    double[] v = {0, 0, 0, 0}; //average wavenumbers
    double[] U = {0, .0032, .0023, .0002};
    double[] n = {1, 1, 1, 1}; //refractive index
    double[] Om = {0, 0, 0, 0};
    double[] D = {0, 0, 0, 0}; //Dipole strengths together with refractive index corrections
    double[] RT = {0, 0, 0, 0};
    double[] BR = {0, 0, 0, 0}; //Branching ratios
    double[] BR2 = {0, 0, 0, 0}; //Branching ratios
    double AR = 0.0; //Total radiative transition probability
    double ANR = 0.0; //Nonradiative transition probability
    double tauRadCalc = 0.0; //Calculated Radiative Lifetime
    double tauRadTh = 0.0; //Theretical Radiative Lifetime
    double tauObs = 0.0; //Observed lifetime
    double[] sigma = {0, 0, 0, 0}; //Cross section
    double P = 0.0; //Optical Gain
    double eta = 0.0; //Quantum efficiency
    double etaSens = 0.0; //Senzitization efficiency
    double Phi = 0.0; //Overall Quantym Yield
    double[][] wavelengthRefractive = new double[56][6]; //matrix of points for Refractive Index Data calculation
    String title1 = "JOES";
    String title2 = "Judd-Ofelt from Emission Spectra";
    double[] xL = new double[100000];
    double[] yL = new double[100000];
    boolean importFile = false;
    double[] maxPeak = {0, 0}; //Peak maximum x=wavelength, y=intensity
    double[] minL = {1, 1, 1, 1}; //wavelength
    double[] maxL = {1, 1, 1, 1}; //wavelength
    String pointGroupSymmetry = "A";
    String pointGroupSymmetrySub = "b";
    double asymmetricRatio = 1;
    int[] numberOfBands = {0, 0, 0, 0, 0};

    /**
     * Creates new form JOES_UI
     */
    public JOES_UI() {
        initComponents();
        setIcon();
    }

    private void setIcon() {
        setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("icon.png")));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        fileChoosertxt = new javax.swing.JFileChooser();
        RefractiveIndexChoiceRadioGroup = new javax.swing.ButtonGroup();
        FileChooserjoes = new javax.swing.JFileChooser();
        SpectraUnitbuttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        refractiveIndexSelection = new javax.swing.JComboBox<>();
        PhiTextField = new javax.swing.JTextField();
        tauObsTextField = new javax.swing.JTextField();
        radioButtonW = new javax.swing.JRadioButton();
        radioButtonCounts = new javax.swing.JRadioButton();
        jLabel17 = new javax.swing.JLabel();
        RemoveBackground = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TextArea = new javax.swing.JTextArea();
        drawingPanel = new PPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        Table = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        CalculateButton = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jComboBox7F0 = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        jComboBox7F1 = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        jComboBox7F2 = new javax.swing.JComboBox<>();
        jLabel10 = new javax.swing.JLabel();
        jComboBox7F3 = new javax.swing.JComboBox<>();
        jLabel11 = new javax.swing.JLabel();
        jComboBox7F4 = new javax.swing.JComboBox<>();
        jLabel6 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        pointGroupSymmetryLabel = new javax.swing.JLabel();
        asymmetricRatioLabel = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        checkboxNano = new javax.swing.JCheckBox();
        fillingFactor = new javax.swing.JTextField();
        nmed = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        ImportDatabase = new javax.swing.JMenuItem();
        loadConfiguration = new javax.swing.JMenuItem();
        saveConfiguration = new javax.swing.JMenuItem();
        createReport = new javax.swing.JMenuItem();
        Exit = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        helpContents = new javax.swing.JMenuItem();
        about = new javax.swing.JMenuItem();

        fileChoosertxt.setDialogTitle("File Open Dialog");
        fileChoosertxt.setFileFilter(new txtFilter());

        FileChooserjoes.setFileFilter(new joesFilter());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JOES - Judd-Ofelt from Emission Spectra");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Input"));
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel4.setText("Refractive Index");
        jPanel1.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, -1, -1));

        refractiveIndexSelection.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "User defined", "Ag - Silver", "AgCl - Silver Chloride", "Al - Aluminium", "Al2O3 - Amorphous, thin film", "AlSb - Aluminium Antimonide", "Au - Gold", "B4C - Boron Carbide", "Be - Beryllium", "Bi - Bismuth", "BiFeO3 - Bismuth ferrite, BFO", "C - Carbon, Amorphous thin film", "C - Carbon, Diamond", "C - Carbon, Graphene", "C - Carbon, Graphite", "CdTe - Cadmium Telluride", "Co - Cobalt", "Cr - Chromium", "Cu - Copper", "Fe - Iron", "Fe2O3 - Iron Sesquioxide, Hematite", "Fe3O4 - Iron (II, III) oxide, Magnetite", "GaP - Gallium Phosphide", "GaSb - Gallium Antimonide", "Ge - Germanium", "Hg - Mercury", "In - Indium", "Li - Lithium", "Lu - Lutetium", "Mg - Magnesium", "MgO3 - Molybdenum Trioxide, alpha phase", "MgO3 - Molybdenum Trioxide, Amorphous", "Mn - Manganese", "Mo - Molybdenum", "MoS2 - Molybdenum Disulfide, Film", "MoSe2 - Molybdenum Diselenide", "Na - Sodium", "Nb - Niobium", "Nb2O5 - Niobium pentoxide", "Ni - Nickel", "Pb - Lead", "Pd - Palladium", "Pt - Platinum", "Rh - Rhodium", "Si - Silicon", "SiC - Silicon Carbide, Thin film", "SiO - Silicon Monoxide", "SiO2 - Silicon Dioxide, Silica, Quartz, Fused Silica", "SiO2 - Silicon Dioxide, Silica, Quartz, Thin Film", "Ta - Tantalum", "Ta2O5 - Tantalum Pentoxide, Amorphous film", "Ta2O5 - Tantalum Pentoxide, Nanocrystalline film", "Ti - Titanium", "TiO2 - Titanium Dioxide, Thin film", "V - Vanadium", "W - Tungsten", "Zn - Zinc", "Ag3AsS3 - Silver Arsenic Sulfide", "AgGaS2 - Silver Gallium Sulfide, AGS", "Al2O3 - Sapphire (corundum), crystal", "AlAs - Aluminium Arsenide", "AlN - Aluminium Nitride", "As2S3 - Arsenic Trisulfide", "BaB2O4 - Barium Borate, BBO", "BaF2 - Barium Fluoride", "BeO - Beryllium Monoxide", "Bi12GeO20 - Bismuth Germanate, BGO", "Bi4Ge3O12 - Bismuth Germanate, BGO", "BiB3O6 - Bismuth Triborate, BiBO", "CaCO3 - Calcium Carbonate, Calcite", "CaF2 - Calcium Fluoride", "CaMoO4 - Calcium Molybdate", "CaWO4 - Calcium Tungstate", "CdGeAs2 - Cadmium Germanium Arsenide", "CdS - Cadmium Sulfide", "CS2 - Carbon Disulfide", "CsBr - Cesium Bromide", "CsCl - Cesium Chloride", "CsF - Cesium Fluoride", "CsI - Cesium Iodide", "CsLiB6O10 - Cesium Lithium Borate, CLBO", "CuCl - Cuprous Chloride", "CuGaS2 - Copper Gallium Sulfide", "GaAs - Gallium Arsenide", "GaN - Gallium Nitride", "GaS - Gallium Sulfide", "GeO2 - Germanium Dioxide, Germania", "HfO2 - Hafnium Dioxide, Hafnia (Cubic)", "HgS - Mercury Sulfide", "InAs - Indium Arsenide", "InP - Indium Phosphide", "KBr - Potassium Bromide", "KCl - Potassium Chloride", "KF - Potassium Fluoride", "KH2PO4 - Potassium Dihydrogen Phosphate, KDP", "KI - Potassium Iodide", "KNbO3 - Potassium Niobate", "KTaO3 - Potassium Tantalate", "KTiOPO4 - Potassium Titanyl Phosphate, KTP", "LaF3 - Lanthanum Fluoride", "LiB3O5 - Lithium Triborate, LBO", "LiBr - Lithium Bromide", "LiCaAlF6 - Lithium Calcium Aluminum Fluoride, LiCAF", "LiCl - Lithium Chloride", "LiF - Lithium Fluoride", "LiI - Lithium Iodide", "LiIO3 - Lithium Iodate", "LiNbO3 - Lithium Niobate", "LuAl3(BO3)4 - Lutetium Aluminum Borate, LuAB", "MgAl2O4 - Magnesium Aluminate, spinel", "MgF - Magnesium Fluoride", "MgO - Magnesium Monoxide", "NaBr - Sodium Bromide", "NaCl - Sodium Chloride", "NaF - Sodium Fluoride", "NaI - Sodium Iodide", "NH3 - Ammonia", "NH4H2PO4 - Ammonium Dihydrogen Phosphate, ADP", "Pb4Ge3O11 - Lead Germanate, PGO", "PbF2 - Lead Difluoride", "PbMoO4 - Lead Molybdate", "PbTiO3 - Lead Titanate", "RbBr - Rubidium Bromide", "RbCl - Rubidium Chloride", "RbF - Rubidium Fluoride", "RbI - Rubidium Iodide", "RbTiOPO4 - Rubidium Titanyl Phosphate, RTP", "Si3N4 - Silicon Nitride", "SiC - Silicon Carbide, Single crystal", "SiO2 - Silicon Dioxide, Silica, Quartz, Crystal", "SrF2 - Strontium Fluoride", "SrMoO4 - Strontium Molybdate", "SrTiO3 - Strontium Titanate, STO", "TeO2 - Tellurium dioxide", "ThF4 - Thorium Tetrafluoride", "TiO2 - Titanium Dioxide, Crystal", "TiO2 - Titanium Dioxide, nanoparticles", "TlBr - Thallium Bromide", "Y2O3 - Yttrium Sesquioxide", "Y3Al5O12 - Yttrium Aluminium Garnet, YAG", "YLiF4 - Yttrium Lithium Fluoride, YLF", "YVO4 - Yttrium Vanadate", "ZnO - Zink Monoxide", "ZnSe - Zinc Selenide", "ZnSiAs2 - Zink Silicon Arsenide", "ZnSiAs2 - Zink Sulfide", "ZnTe - Zinc Telluride", "ZrO2 - Zirconium Dioxide, Zirconia, Cubic phase, stabilized with Y2O3" }));
        refractiveIndexSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refractiveIndexSelectionActionPerformed(evt);
            }
        });
        jPanel1.add(refractiveIndexSelection, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 60, 180, 20));

        PhiTextField.setText("Overall Quantum Yield");
        PhiTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PhiTextFieldActionPerformed(evt);
            }
        });
        jPanel1.add(PhiTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 90, 140, -1));

        tauObsTextField.setText("Observable Lifetime");
        tauObsTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tauObsTextFieldActionPerformed(evt);
            }
        });
        jPanel1.add(tauObsTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 90, 130, -1));

        SpectraUnitbuttonGroup1.add(radioButtonW);
        radioButtonW.setLabel("W");
        radioButtonW.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonWActionPerformed(evt);
            }
        });
        jPanel1.add(radioButtonW, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 40, -1, -1));

        SpectraUnitbuttonGroup1.add(radioButtonCounts);
        radioButtonCounts.setSelected(true);
        radioButtonCounts.setText("Counts (default)");
        radioButtonCounts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonCountsActionPerformed(evt);
            }
        });
        jPanel1.add(radioButtonCounts, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 40, -1, -1));

        jLabel17.setText("Spectrum Units:");
        jPanel1.add(jLabel17, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, -1, -1));

        RemoveBackground.setText("Remove Background (Minimum)");
        RemoveBackground.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveBackgroundActionPerformed(evt);
            }
        });
        jPanel1.add(RemoveBackground, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 120, -1, -1));

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Input Data Preview"));

        TextArea.setColumns(20);
        TextArea.setRows(5);
        jScrollPane1.setViewportView(TextArea);

        drawingPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout drawingPanelLayout = new javax.swing.GroupLayout(drawingPanel);
        drawingPanel.setLayout(drawingPanelLayout);
        drawingPanelLayout.setHorizontalGroup(
            drawingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 481, Short.MAX_VALUE)
        );
        drawingPanelLayout.setVerticalGroup(
            drawingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 276, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 166, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(drawingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(drawingPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 278, Short.MAX_VALUE)
        );

        Table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "min [nm]", "max [nm]", "Area", "Ω [cm²] x 1E20", "Tr. Prob. [1/s]", "β", "n", "ν [1/cm]", "λ [nm]"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Object.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                true, true, true, false, false, false, true, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        Table.setRowHeight(19);
        jScrollPane2.setViewportView(Table);

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/transitions.png"))); // NOI18N

        CalculateButton.setBackground(new java.awt.Color(255, 51, 51));
        CalculateButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        CalculateButton.setForeground(new java.awt.Color(255, 255, 255));
        CalculateButton.setText("Calculate");
        CalculateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CalculateButtonActionPerformed(evt);
            }
        });

        jLabel14.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/wavelengthColor.png"))); // NOI18N

        jLabel18.setText("CIE calculations are moved to a new Project, doi will be soon given here");

        jLabel19.setText("doi: 10.1016/j.jlumin.2018.09.048");

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Symmetry - Europium as a spectroscopic probe"));
        jPanel4.setMinimumSize(new java.awt.Dimension(950, 100));
        jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel5.setText("Number of emission bands for terminal state: ");
        jPanel4.add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 16, -1, -1));

        jLabel7.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/7F0.png"))); // NOI18N
        jPanel4.add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 35, -1, -1));

        jComboBox7F0.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1" }));
        jComboBox7F0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7F0ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox7F0, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 40, -1, -1));

        jLabel8.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/7F1.png"))); // NOI18N
        jPanel4.add(jLabel8, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 35, -1, -1));

        jComboBox7F1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1", "2", "3" }));
        jComboBox7F1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7F1ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox7F1, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 40, -1, -1));

        jLabel9.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/7F2.png"))); // NOI18N
        jPanel4.add(jLabel9, new org.netbeans.lib.awtextra.AbsoluteConstraints(150, 35, -1, -1));

        jComboBox7F2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1", "2", "3", "4", "5" }));
        jComboBox7F2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7F2ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox7F2, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 40, -1, -1));

        jLabel10.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/7F3.png"))); // NOI18N
        jPanel4.add(jLabel10, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 35, -1, -1));

        jComboBox7F3.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1", "2", "3", "4", "5", "6", "7" }));
        jComboBox7F3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7F3ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox7F3, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 40, -1, -1));

        jLabel11.setIcon(new javax.swing.ImageIcon(getClass().getResource("/my/joes/7F4.png"))); // NOI18N
        jPanel4.add(jLabel11, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 35, -1, -1));

        jComboBox7F4.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" }));
        jComboBox7F4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7F4ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox7F4, new org.netbeans.lib.awtextra.AbsoluteConstraints(320, 40, -1, -1));

        jLabel6.setText("Point Group Symmetry:");
        jPanel4.add(jLabel6, new org.netbeans.lib.awtextra.AbsoluteConstraints(380, 40, -1, -1));

        jLabel12.setText("Asymmetric Ratio, R = ");
        jPanel4.add(jLabel12, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 40, -1, -1));
        jPanel4.add(jLabel13, new org.netbeans.lib.awtextra.AbsoluteConstraints(910, 40, -1, -1));

        pointGroupSymmetryLabel.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        pointGroupSymmetryLabel.setText("<html>" + pointGroupSymmetry + "<sub>" + pointGroupSymmetrySub + "</sub></html>");
        jPanel4.add(pointGroupSymmetryLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(520, 40, -1, -1));
        jPanel4.add(asymmetricRatioLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(915, 40, -1, -1));

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Nanoparticles"));

        checkboxNano.setText("Is particle diameter much smaller");
        checkboxNano.setToolTipText("");
        checkboxNano.setActionCommand("");
        checkboxNano.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkboxNanoActionPerformed(evt);
            }
        });

        fillingFactor.setText("Filling Factor");
        fillingFactor.setToolTipText("");
        fillingFactor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fillingFactorActionPerformed(evt);
            }
        });

        nmed.setText("Surrouning Media Refractive Index");

        jLabel2.setText("than emission wavelength?");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(jLabel2))
                    .addComponent(checkboxNano, javax.swing.GroupLayout.PREFERRED_SIZE, 277, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(fillingFactor, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(nmed, javax.swing.GroupLayout.PREFERRED_SIZE, 228, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(64, 64, 64))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(checkboxNano, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(fillingFactor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(nmed, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(9, 9, 9))
        );

        checkboxNano.getAccessibleContext().setAccessibleName("");

        jLabel20.setText("By using this software cite following article:");

        jLabel3.setText(" ┌────── INPUT ──────┐ ");

        jMenu1.setText("File");

        ImportDatabase.setText("Import I(λ) spectrum");
        ImportDatabase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ImportDatabaseActionPerformed(evt);
            }
        });
        jMenu1.add(ImportDatabase);

        loadConfiguration.setText("Open");
        loadConfiguration.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadConfigurationActionPerformed(evt);
            }
        });
        jMenu1.add(loadConfiguration);

        saveConfiguration.setText("Save");
        saveConfiguration.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveConfigurationActionPerformed(evt);
            }
        });
        jMenu1.add(saveConfiguration);

        createReport.setText("Create Report");
        createReport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createReportActionPerformed(evt);
            }
        });
        jMenu1.add(createReport);

        Exit.setText("Exit");
        Exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitActionPerformed(evt);
            }
        });
        jMenu1.add(Exit);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Help");

        helpContents.setText("Help Contents");
        helpContents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpContentsActionPerformed(evt);
            }
        });
        jMenu2.add(helpContents);

        about.setText("About");
        about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutActionPerformed(evt);
            }
        });
        jMenu2.add(about);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
                            .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                        .addGap(33, 33, 33)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGap(9, 9, 9)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel14)
                                            .addGroup(layout.createSequentialGroup()
                                                .addGap(18, 18, 18)
                                                .addComponent(jLabel18)))
                                        .addGap(26, 26, 26)
                                        .addComponent(CalculateButton, javax.swing.GroupLayout.PREFERRED_SIZE, 176, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jLabel19)
                                        .addGap(110, 110, 110))))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel3)
                                        .addGap(0, 0, Short.MAX_VALUE))
                                    .addComponent(jScrollPane2))))))
                .addContainerGap())
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                    .addContainerGap(724, Short.MAX_VALUE)
                    .addComponent(jLabel20)
                    .addGap(87, 87, 87)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(5, 5, 5)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 167, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addGap(4, 4, 4)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(jLabel1))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(48, 48, 48)
                        .addComponent(jLabel19))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(CalculateButton, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                    .addContainerGap(458, Short.MAX_VALUE)
                    .addComponent(jLabel20, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(128, 128, 128)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ImportDatabaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ImportDatabaseActionPerformed
        //Open file and parse to array
        String line = "";
        String textareatext = "";
        int returnVal = fileChoosertxt.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fileChoosertxt.getSelectedFile();

            try (BufferedReader br = new BufferedReader(new FileReader(file))) {
                // Display File in a TextArea
                TextArea.read(new FileReader(file.getAbsolutePath()), null);
          
                // Put columns in arrays and get max size, x=wavelength, y=intensity
                while ((line = br.readLine()) != null) {
                    line = line.replace("\t", ",");
                    String[] field = line.split(",");
                    xL[m] = Double.parseDouble(field[0]);
                    yL[m] = Double.parseDouble(field[1]);
                    m++;
                }
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        drawSpectra();
                    }
                });

            } catch (IOException ex) {
                System.out.println("problem accessing file" + file.getAbsolutePath());
            }
        } else {
            System.out.println("File access cancelled by user.");
        }
        importFile = true;

    }//GEN-LAST:event_ImportDatabaseActionPerformed

    private void ExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitActionPerformed
        System.exit(0);
    }//GEN-LAST:event_ExitActionPerformed

    public double[] CalculateCrossSection() {
        double c = 2.998 * pow(10, 10); //speed of light in cm/s
        double[] maxI = {0, 0, 0, 0};
        double[] maxX = {0, 0, 0, 0};
        double[] nL;
        double[] maxV = {0, 0, 0, 0};
        double[] maxXcm = {0, 0, 0, 0};
        double[] ALcm = {0, 0, 0, 0};

        for (int i = 0; i < 4; i++) {//for all 4 transitions
            for (int j = 0; j < m; j++) { //for all the entries, j gives the index of the entry
                if (minL[i] < xL[j] && maxL[i] > xL[j]) { //if those peaks are within the range provided
                    if (yL[j] > maxI[i]) { //if the value is greater than the current maximum
                        maxI[i] = yL[j]; //set that value to be the maximum
                        maxX[i] = xL[j]; //peak wavelengths
                    }
                    A[i] = A[i] + .5 * (xL[j + 1] - xL[j]) * (yL[j] + yL[j + 1]); //Peak area in nm
                }
            }
            maxV[i] = 10000000 / maxX[i]; //wavenumbers of maxima, in cm^-1
            maxXcm[i] = maxX[i] / 10000000; //wavelengths in cm
            ALcm[i] = A[i] / 10000000; //Peak area in cm
            nL = CalculateRefractiveIndex(maxV); //return refractive indexes of peak maxima
            sigma[i] = pow(maxXcm[i], 4) * maxI[i] * RT[i] / (8 * Math.PI * c * pow(nL[i], 2) * ALcm[i]); //Unit must be in cm^2
        }
        return sigma;
    }

    public double[] CalculateRefractiveIndex(double v[]) {
        double[] n = {1, 1, 1, 1};
        //Get Data from CSV
        int p = 0;
        String line = "";
        try (BufferedReader br = new BufferedReader(new FileReader("refractiveIndex.csv"))) {
            // Put columns in arrays and get max size
            while ((line = br.readLine()) != null && p < 57) {
                String[] field = line.split(",");
                for (int i = 0; i < 6; i++) { //3x min and 3x max
                    wavelengthRefractive[p][i] = Double.parseDouble(field[i]);
                }
                p++;
            }
        } catch (IOException ex) {
            System.out.println("problem accessing csv file");
        }
        //Calculate Refractive Indexes
        int rIS = refractiveIndexSelection.getSelectedIndex();
        double[] xv = new double[4];
        if (rIS == 0) { //User defined n
            try {
                for (int i = 0; i < 3; i++) {
                    n[i] = Double.parseDouble(String.valueOf(Table.getValueAt(i, 6)));
                }
                //Ensure that n for 7F6 is not necessary
                if(Table.getValueAt(3, 6) != null){
                    n[3] = Double.parseDouble(String.valueOf(Table.getValueAt(3, 6)));
                    System.out.println(n[3]);
                }
                else {
                    n[3] = n[2]; //Assign it the value of 7F4
                }
            } catch (NumberFormatException ex) {
                // Set alert and exception if no value is entered or is of invalid type
                for (int i = 0; i < 4; i++) {
                    n[i] = 2;
                }
                popupWarning("Error", "Please enter the value for Refractive Index (n) correctly, or choose one from the list. For now, n will be set to 2");
            }
        } else if (rIS <= 56 && rIS > 0) { //From the database
            // rIS-1 because in selection the 0th element is User defined n, while at our database 0th element corresponds to the 1st element in the combobox
            n[1] = (wavelengthRefractive[rIS - 1][1] - wavelengthRefractive[rIS - 1][0]) / 20 * (10000000 / v[1] - 610) + wavelengthRefractive[rIS - 1][0];
            n[2] = (wavelengthRefractive[rIS - 1][3] - wavelengthRefractive[rIS - 1][2]) / 30 * (10000000 / v[2] - 680) + wavelengthRefractive[rIS - 1][2];
            n[3] = (wavelengthRefractive[rIS - 1][5] - wavelengthRefractive[rIS - 1][4]) / 30 * (10000000 / v[3] - 810) + wavelengthRefractive[rIS - 1][4];
            // Set n[0] at 585 nm, approximative, but OK
            n[0] = wavelengthRefractive[rIS - 1][0];
        } else if (rIS >= 57) { //dispersive relations start here
            for (int i = 0; i < 4; i++) {
                xv[i] = 10000 / v[i]; //xv is in micrometers
                if (rIS == 57) {
                    n[i] = sqrt(7.483 + 0.474 / (pow(xv[i], 2) - 0.09) - 0.0019 * pow(xv[i], 2));
                }
                if (rIS == 58) {
                    n[i] = sqrt(5.7975 + 0.2311 / (pow(xv[i], 2) - 0.0688) - 0.00257 * pow(xv[i], 2));
                }
                if (rIS == 59) {
                    n[i] = sqrt(1 + 1.4313493 / (1 - pow(0.0726631 / xv[i], 2)) + 0.65054713 / (1 - pow(0.1193242 / xv[i], 2)) + 5.3414021 / (1 - pow(18.028251 / xv[i], 2)));
                }
                if (rIS == 60) {
                    n[i] = sqrt(1 + 1.0792 + 6.0840 / (1 - pow(0.2822 / xv[i], 2)) + 1.900 / (1 - pow(27.62 / xv[i], 2)));
                }
                if (rIS == 61) {
                    n[i] = sqrt(1 + 2.1399 + 1.3786 / (1 - pow(0.1715 / xv[i], 2)) + 3.861 / (1 - pow(15.03 / xv[i], 2)));
                }
                if (rIS == 62) {
                    n[i] = sqrt(1 + 1.8983678 / (1 - 0.0225 / pow(xv[i], 2)) + 1.9222979 / (1 - 0.0625 / pow(xv[i], 2)) + 0.8765134 / (1 - 0.1225 / pow(xv[i], 2)) + 0.1188704 / (1 - 0.2025 / pow(xv[i], 2)) + 0.9569903 / (1 - 750 / pow(xv[i], 2)));
                }
                if (rIS == 63) {
                    n[i] = sqrt(2.7405 + 0.0184 / (pow(xv[i], 2) - 0.0179) - 0.0155 * pow(xv[i], 2));
                }
                if (rIS == 64) {
                    n[i] = sqrt(1 + 0.33973 + 0.81070 / (1 - pow(0.10065 / xv[i], 2)) + 0.19652 / (1 - pow(29.87 / xv[i], 2)) + 4.52469 / (1 - pow(53.82 / xv[i], 2)));
                }
                if (rIS == 65) {
                    n[i] = sqrt(1 + 1.92274 / (1 - pow(0.07908 / xv[i], 2)) + 1.24209 / (1 - pow(9.7131 / xv[i], 2)));
                }
                if (rIS == 66) {
                    n[i] = sqrt(1 + 2.165 + 2.655 / (1 - 0.07891 / pow(xv[i], 2)));
                }
                if (rIS == 67) {
                    n[i] = sqrt(1 + 3.1218393 / (1 - pow(0.1807 / xv[i], 2)));
                }
                if (rIS == 68) {
                    n[i] = sqrt(3.07403 + 0.03231 / (pow(xv[i], 2) - 0.03163) - 0.013376 * pow(xv[i], 2));
                }
                if (rIS == 69) {
                    n[i] = sqrt(1 + 0.73358749 + 0.96464345 / (1 - 1.94325203e-2 / pow(xv[i], 2)) + 1.82831454 / (1 - 120 / pow(xv[i], 2)));
                }
                if (rIS == 70) {
                    n[i] = sqrt(1 + 0.33973 + 0.69913 / (1 - pow(0.09374 / xv[i], 2)) + 0.11994 / (1 - pow(21.18 / xv[i], 2)) + 4.35181 / (1 - pow(38.46 / xv[i], 2)));
                }
                if (rIS == 71) {
                    n[i] = sqrt(1 + 2.7840 / (1 - pow(0.1483 / xv[i], 2)) + 1.2425 / (1 - pow(11.576 / xv[i], 2)));
                }
                if (rIS == 72) {
                    n[i] = sqrt(1 + 2.5493 / (1 - pow(0.1347 / xv[i], 2)) + 0.9200 / (1 - pow(10.815 / xv[i], 2)));
                }
                if (rIS == 73) {
                    n[i] = sqrt(1 + 9.1064 + 2.2988 / (1 - 1.0872 / pow(xv[i], 2)) + 1.6247 / (1 - 1370 / pow(xv[i], 2)));
                }
                if (rIS == 74) {
                    n[i] = sqrt(5.1792 + 0.23504 / (pow(xv[i], 2) - 0.083591) + 0.036927 / (pow(xv[i], 2) - 0.23504));
                }
                if (rIS == 75) {
                    n[i] = sqrt(1 + 1.50387 / (1 - 0.03049 / pow(xv[i], 2)));
                }
                if (rIS == 76) {
                    n[i] = sqrt(1 + 0.9533786 / (1 - pow(0.0905643 / xv[i], 2)) + 0.8303809 / (1 - pow(0.1671517 / xv[i], 2)) + 2.847172 / (1 - pow(119.0155 / xv[i], 2)));
                }
                if (rIS == 77) {
                    n[i] = sqrt(1 + 0.33013 + 0.98369 / (1 - pow(0.119 / xv[i], 2)) + 0.00009 / (1 - pow(0.137 / xv[i], 2)) + 0.00018 / (1 - pow(0.145 / xv[i], 2)) + 0.30914 / (1 - pow(0.162 / xv[i], 2)) + 4.320 / (1 - pow(100.50 / xv[i], 2)));
                }
                if (rIS == 78) {
                    n[i] = sqrt(1 + 0.60 + 0.56 / (1 - pow(0.121 / xv[i], 2)) + 5.92 / (1 - pow(78.74 / xv[i], 2)));
                }
                if (rIS == 79) {
                    n[i] = sqrt(1 + 0.34617251 / (1 - pow(0.0229567 / xv[i], 2)) + 1.0080886 / (1 - pow(0.1466 / xv[i], 2)) + 0.28551800 / (1 - pow(0.1810 / xv[i], 2)) + 0.39743178 / (1 - pow(0.2120 / xv[i], 2)) + 3.3605359 / (1 - pow(161.0 / xv[i], 2)));
                }
                if (rIS == 80) {
                    n[i] = sqrt(2.2104 + 0.01018 / (pow(xv[i], 2) - 0.01424) - 0.01258 * pow(xv[i], 2));
                }
                if (rIS == 81) {
                    n[i] = sqrt(3.580 + 0.03162 * pow(xv[i], 2) / (pow(xv[i], 2) - 0.1642) + 0.09288 * pow(xv[i], -2));
                }
                if (rIS == 82) {
                    n[i] = sqrt(1 + 2.9064 + 2.3065 / (1 - 0.1149 / pow(xv[i], 2)) + 1.5479 / (1 - 738.43 / pow(xv[i], 2)));
                }
                if (rIS == 83) {
                    n[i] = sqrt(1 + 4.372514 + 5.466742 / (1 - pow(0.4431307 / xv[i], 2)) + 0.02429960 / (1 - pow(0.8746453 / xv[i], 2)) + 1.957522 / (1 - pow(36.9166 / xv[i], 2)));
                }
                if (rIS == 84) {
                    n[i] = sqrt(1 + 2.60 + 1.75 / (1 - pow(0.256 / xv[i], 2)) + 4.1 / (1 - pow(17.86 / xv[i], 2)));
                }
                if (rIS == 85) {
                    n[i] = sqrt(7.12996 + 0.26073 / (pow(xv[i], 2) - 0.04627) + 127.335 / (pow(xv[i], 2) - 258.431));
                }
                if (rIS == 86) {
                    n[i] = sqrt(1 + 0.80686642 / (1 - pow(0.068972606 / xv[i], 2)) + 0.71815848 / (1 - pow(0.15396605 / xv[i], 2)) + 0.85416831 / (1 - pow(11.841931 / xv[i], 2)));
                }
                if (rIS == 87) {
                    n[i] = sqrt(1 + 1.9558 / (1 - pow(0.15494 / xv[i], 2)) + 1.345 / (1 - pow(0.0634 / xv[i], 2)) + 10.41 / (1 - pow(27.12 / xv[i], 2)));
                }
                if (rIS == 88) {
                    n[i] = sqrt(1 + 3.1506 + 2.7896 / (1 - 0.1328 / pow(xv[i], 2)) + 1.1378 / (1 - 705 / pow(xv[i], 2)));
                }
                if (rIS == 89) {
                    n[i] = sqrt(1 + 10.1 + 0.71 / (1 - pow(2.551 / xv[i], 2)) + 2.75 / (1 - pow(45.66 / xv[i], 2)));
                }
                if (rIS == 90) {
                    n[i] = sqrt(1 + 6.255 + 2.316 / (1 - pow(0.6263 / xv[i], 2)) + 2.765 / (1 - pow(32.935 / xv[i], 2)));
                }
                if (rIS == 91) {
                    n[i] = sqrt(1 + 0.39408 + 0.79221 / (1 - pow(0.146 / xv[i], 2)) + 0.01981 / (1 - pow(0.173 / xv[i], 2)) + 0.15587 / (1 - pow(0.187 / xv[i], 2)) + 0.17673 / (1 - pow(60.61 / xv[i], 2)) + 2.06217 / (1 - pow(87.72 / xv[i], 2)));
                }
                if (rIS == 92) {
                    n[i] = sqrt(1 + 0.26486 + 0.30523 / (1 - pow(0.100 / xv[i], 2)) + 0.41620 / (1 - pow(0.131 / xv[i], 2)) + 0.18870 / (1 - pow(0.162 / xv[i], 2)) + 2.6200 / (1 - pow(70.42 / xv[i], 2)));
                }
                if (rIS == 93) {
                    n[i] = sqrt(1 + 0.55083 + 0.29162 / (1 - pow(0.126 / xv[i], 2)) + 3.60001 / (1 - pow(51.55 / xv[i], 2)));
                }
                if (rIS == 94) {
                    n[i] = sqrt(2.259276 + 13.00522 * pow(xv[i], 2) / (pow(xv[i], 2) - 400) + 0.01008956 / (pow(xv[i], 2) - 0.0129426));
                }
                if (rIS == 95) {
                    n[i] = sqrt(1 + 0.47285 + 0.16512 / (1 - pow(0.129 / xv[i], 2)) + 0.41222 / (1 - pow(0.175 / xv[i], 2)) + 0.44163 / (1 - pow(0.187 / xv[i], 2)) + 0.16076 / (1 - pow(0.219 / xv[i], 2)) + 0.33571 / (1 - pow(69.44 / xv[i], 2)) + 1.92474 / (1 - pow(98.04 / xv[i], 2)));
                }
                if (rIS == 96) {
                    n[i] = sqrt(4.4222 + 0.09972 / (pow(xv[i], 2) - 0.05496) - 0.01976 * pow(xv[i], 2));
                }
                if (rIS == 97) {
                    n[i] = sqrt(1 + 3.591 / (1 - pow(0.193 / xv[i], 2)));
                }
                if (rIS == 98) {
                    n[i] = sqrt(3.29100 + 0.04140 / (pow(xv[i], 2) - 0.03978) + 9.35522 / (pow(xv[i], 2) - 31.45571));
                }
                if (rIS == 99) {
                    n[i] = sqrt(1 + 1.5376 / (1 - pow(0.0881 / xv[i], 2)));
                }
                if (rIS == 100) {
                    n[i] = sqrt(2.45768 + 0.0098877 / (pow(xv[i], 2) - 0.026095) - 0.013847 * pow(xv[i], 2));
                }
                if (rIS == 101) {
                    n[i] = sqrt(1 + 1.88 + 0.28 / (1 - pow(0.164 / xv[i], 2)) + 10.07 / (1 - pow(57.80 / xv[i], 2)));
                }
                if (rIS == 102) {
                    n[i] = sqrt(1.92552 + 0.00492 / (pow(xv[i], 2) - 0.00569) - 0.00421 * pow(xv[i], 2));
                }
                if (rIS == 103) {
                    n[i] = sqrt(1 + 1.51 + 0.24 / (1 - pow(0.137 / xv[i], 2)) + 9.11 / (1 - pow(49.26 / xv[i], 2)));
                }
                if (rIS == 104) {
                    n[i] = sqrt(1 + 0.92549 / (1 - pow(0.07376 / xv[i], 2)) + 6.96747 / (1 - pow(32.790 / xv[i], 2)));
                }
                if (rIS == 105) {
                    n[i] = sqrt(1 + 2.55 + 0.25 / (1 - pow(0.171 / xv[i], 2)) + 7.23 / (1 - pow(70.42 / xv[i], 2)));
                }
                if (rIS == 106) {
                    n[i] = sqrt(1 + 1.03132 + 1.37623 / (1 - 0.0350832 / pow(xv[i], 2)) + 1.06745 / (1 - 169.00 / pow(xv[i], 2)));
                }
                if (rIS == 107) {
                    n[i] = sqrt(1 + 2.6734 / (1 - 0.01764 / pow(xv[i], 2)) + 1.2290 / (1 - 0.05914 / pow(xv[i], 2)) + 12.614 / (1 - 474.60 / pow(xv[i], 2)));
                }
                if (rIS == 108) {
                    n[i] = sqrt(3.11285 + 0.01834 / (pow(xv[i], 2) - 0.01596) - 0.02354 * pow(xv[i], 2));
                }
                if (rIS == 109) {
                    n[i] = sqrt(1 + 1.8938 / (1 - pow(0.09942 / xv[i], 2)) + 3.0755 / (1 - pow(15.826 / xv[i], 2)));
                }
                if (rIS == 110) {
                    n[i] = sqrt(1 + 0.48755108 / (1 - pow(0.04338408 / xv[i], 2)) + 0.39875031 / (1 - pow(0.09461442 / xv[i], 2)) + 2.3120353 / (1 - pow(23.793604 / xv[i], 2)));
                }
                if (rIS == 111) {
                    n[i] = sqrt(2.956362 + 0.02195770 / (pow(xv[i], 2) - 0.01428322) - 0.01062387 * pow(xv[i], 2) - 0.0000204968 * pow(xv[i], 4));
                }
                if (rIS == 112) {
                    n[i] = sqrt(1 + 0.06728 + 1.10463 / (1 - pow(0.125 / xv[i], 2)) + 0.18816 / (1 - pow(0.145 / xv[i], 2)) + 0.00243 / (1 - pow(0.176 / xv[i], 2)) + 0.24454 / (1 - pow(0.188 / xv[i], 2)) + 3.7960 / (1 - pow(74.63 / xv[i], 2)));
                }
                if (rIS == 113) {
                    n[i] = sqrt(1 + 0.00055 + 0.19800 / (1 - pow(0.050 / xv[i], 2)) + 0.48398 / (1 - pow(0.100 / xv[i], 2)) + 0.38696 / (1 - pow(0.128 / xv[i], 2)) + 0.25998 / (1 - pow(0.158 / xv[i], 2)) + 0.08796 / (1 - pow(40.50 / xv[i], 2)) + 3.17064 / (1 - pow(60.98 / xv[i], 2)) + 0.30038 / (1 - pow(120.34 / xv[i], 2)));
                }
                if (rIS == 114) {
                    n[i] = sqrt(1 + 0.41572 + 0.32785 / (1 - pow(0.117 / xv[i], 2)) + 3.18248 / (1 - pow(40.57 / xv[i], 2)));
                }
                if (rIS == 115) {
                    n[i] = sqrt(1 + 0.478 + 1.532 / (1 - pow(0.170 / xv[i], 2)) + 4.27 / (1 - pow(86.21 / xv[i], 2)));
                }
                if (rIS == 116) {
                    n[i] = 1 + 0.032953 / (90.392 - pow(xv[i], -2));
                }
                if (rIS == 117) {
                    n[i] = sqrt(2.302842 + 15.102464 * pow(xv[i], 2) / (pow(xv[i], 2) - 400) + 0.011125165 / (pow(xv[i], 2) - 0.01325366));
                }
                if (rIS == 118) {
                    n[i] = sqrt(2.470 + 1.687 * pow(xv[i], 2) / (pow(xv[i], 2) - 0.06146));
                }
                if (rIS == 119) {
                    n[i] = sqrt(1 + 0.66959342 / (1 - pow(0.00034911 / xv[i], 2)) + 1.3086319 / (1 - pow(0.17144455 / xv[i], 2)) + 0.01670641 / (1 - pow(0.28125513 / xv[i], 2)) + 2007.8865 / (1 - pow(796.67469 / xv[i], 2)));
                }
                if (rIS == 120) {
                    n[i] = sqrt(1 + 3.54642 / (1 - pow(0.18518 / xv[i], 2)) + 0.58270 / (1 - pow(0.033764 / xv[i], 2)));
                }
                if (rIS == 121) {
                    n[i] = sqrt(1 + 5.3635 / (1 - 0.050267 / pow(xv[i], 2)));
                }
                if (rIS == 122) {
                    n[i] = sqrt(1 + 0.45931 + 0.16301 / (1 - pow(0.123 / xv[i], 2)) + 0.29841 / (1 - pow(0.146 / xv[i], 2)) + 0.17198 / (1 - pow(0.155 / xv[i], 2)) + 0.12186 / (1 - pow(0.178 / xv[i], 2)) + 0.13039 / (1 - pow(0.191 / xv[i], 2)) + 2.520 / (1 - pow(114.29 / xv[i], 2)));
                }
                if (rIS == 123) {
                    n[i] = sqrt(1 + 0.47558 + 0.5600 / (1 - pow(0.138 / xv[i], 2)) + 0.14493 / (1 - pow(0.166 / xv[i], 2)) + 2.74000 / (1 - pow(85.84 / xv[i], 2)));
                }
                if (rIS == 124) {
                    n[i] = sqrt(1 + 0.395 + 0.535 / (1 - pow(0.124 / xv[i], 2)) + 4.55 / (1 - pow(63.29 / xv[i], 2)));
                }
                if (rIS == 125) {
                    n[i] = sqrt(1 + 0.60563 + 0.00947 / (1 - pow(0.120 / xv[i], 2)) + 0.01073 / (1 - pow(0.134 / xv[i], 2)) + 0.00136 / (1 - pow(0.156 / xv[i], 2)) + 0.41864 / (1 - pow(0.179 / xv[i], 2)) + 0.41771 / (1 - pow(0.187 / xv[i], 2)) + 0.13707 / (1 - pow(0.223 / xv[i], 2)) + 2.36091 / (1 - pow(132.45 / xv[i], 2)));
                }
                if (rIS == 126) {
                    n[i] = sqrt(1.6795 + 1.4281 * pow(xv[i], 2) / (pow(xv[i], 2) - 0.0325) - 0.0119 * pow(xv[i], 2));
                }
                if (rIS == 127) {
                    n[i] = sqrt(1 + 3.0249 / (1 - pow(0.1353406 / xv[i], 2)) + 40314 / (1 - pow(1239.842 / xv[i], 2)));
                }
                if (rIS == 128) {
                    n[i] = sqrt(1 + 5.5394 / (1 - 0.026945 / pow(xv[i], 2)));
                }
                if (rIS == 129) {
                    n[i] = sqrt(1 + 0.28604141 + 1.07044083 / (1 - 1.00585997e-2 / pow(xv[i], 2)) + 1.10202242 / (1 - 100 / pow(xv[i], 2)));
                }
                if (rIS == 130) {
                    n[i] = sqrt(1 + 0.33973 + 0.7097 / (1 - pow(0.09597 / xv[i], 2)) + 0.1788 / (1 - pow(26.03 / xv[i], 2)) + 3.8796 / (1 - pow(45.60 / xv[i], 2)));
                }
                if (rIS == 131) {
                    n[i] = sqrt(1 + 2.4839 / (1 - pow(0.1451 / xv[i], 2)) + 0.1015 / (1 - pow(4.603 / xv[i], 2)));
                }
                if (rIS == 132) {
                    n[i] = sqrt(1 + 3.042143 / (1 - pow(0.1475902 / xv[i], 2)) + 1.170065 / (1 - pow(0.2953086 / xv[i], 2)) + 30.83326 / (1 - pow(33.18606 / xv[i], 2)));
                }
                if (rIS == 133) {
                    n[i] = sqrt(1 + 2.584 / (1 - pow(0.1342 / xv[i], 2)) + 1.157 / (1 - pow(0.2638 / xv[i], 2)));
                }
                if (rIS == 134) {
                    n[i] = sqrt(1 + 1.2485 / (1 - 0.010466 / pow(xv[i], 2)));
                }
                if (rIS == 135) {
                    n[i] = sqrt(5.913 + 0.2441 / (pow(xv[i], 2) - 0.0803));
                }
                if (rIS == 136) {
                    n[i] = sqrt(1 + 2.578 / (1 - pow(0.1387 / xv[i], 2)) + 3.935 / (1 - pow(22.936 / xv[i], 2)));
                }
                if (rIS == 137) {
                    n[i] = sqrt(1 + 3.7442390 / (1 - pow(0.2079603 / xv[i], 2)) + 0.9189162 / (1 - pow(0.3765643 / xv[i], 2)) + 12.5444602 / (1 - pow(165.6525518 / xv[i], 2)));
                }
                if (rIS == 138) {
                    n[i] = sqrt(1 + 2.578 / (1 - pow(0.1387 / xv[i], 2)) + 3.935 / (1 - pow(22.936 / xv[i], 2)));
                }
                if (rIS == 139) {
                    n[i] = sqrt(1 + 2.28200 / (1 - 0.01185 / pow(xv[i], 2)) + 3.27644 / (1 - 282.734 / pow(xv[i], 2)));
                }
                if (rIS == 140) {
                    n[i] = sqrt(1 + 0.38757 + 0.70757 / (1 - 0.00931 / pow(xv[i], 2)) + 0.18849 / (1 - 50.99741 / pow(xv[i], 2)));
                }
                if (rIS == 141) {
                    n[i] = sqrt(3.778790 + 0.07479 / (pow(xv[i], 2) - 0.045731) - 0.009701 * pow(xv[i], 2));
                }
                if (rIS == 142) {
                    n[i] = sqrt(2.81418 + 0.87968 * pow(xv[i], 2) / (pow(xv[i], 2) - pow(0.3042, 2)) - 0.00711 * pow(xv[i], 2));
                }
                if (rIS == 143) {
                    n[i] = sqrt(1 + 3.00 + 1.90 / (1 - 0.113 / pow(xv[i], 2)));
                }
                if (rIS == 144) {
                    n[i] = sqrt(1 + 3.6006 + 5.6912 / (1 - 0.1437 / pow(xv[i], 2)) + 1.1316 / (1 - 700 / pow(xv[i], 2)));
                }
                if (rIS == 145) {
                    n[i] = sqrt(8.393 + 0.14383 / (pow(xv[i], 2) - pow(0.2421, 2)) + 4430.99 / (pow(xv[i], 2) - pow(36.71, 2)));
                }
                if (rIS == 146) {
                    n[i] = sqrt(9.92 + 0.42530 / (pow(xv[i], 2) - pow(0.37766, 2)) + 8414.13 / (pow(xv[i], 2) - pow(56.5, 2)));
                }
                if (rIS == 147) {
                    n[i] = sqrt(1 + 1.347091 / (1 - pow(0.062543 / xv[i], 2)) + 2.117788 / (1 - pow(0.166739 / xv[i], 2)) + 9.452943 / (1 - pow(24.320570 / xv[i], 2)));
                }
            }
        }
        if(checkboxNano.isSelected()){ //Nano correction
            for (int i=0; i<4;i++){
                try {
                    n[i] = n[i] * Double.parseDouble(fillingFactor.getText()) + (1 - Double.parseDouble(fillingFactor.getText())) * Double.parseDouble(nmed.getText());
                }
                catch (NumberFormatException e){
                    System.out.println("Please enter values!");
                }
            }
        }
        return n;
    }

    private void CalculateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CalculateButtonActionPerformed
        //Check first if the user has imported Origin file
        if (importFile == false) {
            popupWarning("Import file Missing", "Before Calculating, it is required that you provide the input file by clicking File>Import. For more information visit Help");
        }
        //Declaring and initializing variables
        double[] vov = {0, 0, 0, 0};
        double[] AoA = {0, 0, 0, 0};
        double[] B = {0, 0, 0, 0};
        double[] minDefault = {585, 600, 680, 810};
        double[] maxDefault = {600, 640, 715, 840};
        double minimum = 0;
        // Reset Values
        A[0] = 0; A[1] = 0; A[2] = 0; A[3] = 0;
        
        //Get wavelength min and max values from Table
        for (int i = 0; i < 4; i++) {
            if (Table.getValueAt(i, 0) != null) {
                minL[i] = Double.parseDouble(String.valueOf(Table.getValueAt(i, 0)));
            }
            if (Table.getValueAt(i, 1) != null) {
                maxL[i] = Double.parseDouble(String.valueOf(Table.getValueAt(i, 1)));
            }
        }
        //Check if max > min and reverse if not
        for (int i = 0; i < 4; i++) {
            if (minL[i] >= maxL[i] && Table.getValueAt(i, 0) != null && Table.getValueAt(i, 1) != null) {
                popupWarning("Max > Min", "Maximum wavelength must be larger than the min wavelength. For now we will reverse them, but please check the values!");
                double min2max = minL[i];
                double max2min = maxL[i];
                minL[i] = max2min;
                maxL[i] = min2max;
            }
        }
        //Test and correct wavelengths
        for (int i = 0; i < 3; i++) { //7F6 is not necessary
            if (Table.getValueAt(i, 0) == null) { //Value not entered
                popupWarning("Minimum missing", "Value for minimum wavelength for the peak integration must be inserted. The default value will be provided.\nClick on Calculate button again!");
                Table.setValueAt(minDefault[i], i, 0);
            }
            if (Table.getValueAt(i, 1) == null) { //Value not entered
                popupWarning("Maximum missing", "Value for maximum wavelength for the peak integration must be inserted. The default value will be provided.\nClick on Calculate button again!");
                Table.setValueAt(maxDefault[i], i, 1);
            }
        }
        //Find minimum and apply
        if (RemoveBackground.isSelected()){
            for (int k = 0; k < m; k++){ //Find
                if (yL[k] < yL[k+1]){
                    minimum = yL[k];
                }
            }
            for (int k = 0; k < m; k++){ //Apply
                yL[k] = yL[k] - minimum;
            }
        }

        //System.out.println("Minimum = " + minimum);
        // Integrate
        for (int i = 0; i < 4; i++) {
            for (int k = 0; k < m; k++) {
                if ((maxL[i] >= xL[k]) && (minL[i] <= xL[k])) {
                    A[i] = A[i] + .5 * (xL[k + 1] - xL[k]) * (yL[k] + yL[k + 1]);
                    B[i] = B[i] + xL[k] * .5 * (xL[k + 1] - xL[k]) * (yL[k] + yL[k + 1]); //weigthed integral
                }
            }
            v[i] = 10000000*A[i]/B[i] ; //Average wavenumber, barycenter, in cm^-1
            //Write to table: area, average wavenumber and wavelength         
            Table.setValueAt(A[i], i, 2); //Area
            Table.setValueAt(v[i], i, 7); //Barycenter
            Table.setValueAt(10000000 / v[i], i, 8); //Wavelength of barycenter
        }
        //Get Refractive Indexes n[i]
        n = CalculateRefractiveIndex(v);
        //Set n values in the table
        Table.setValueAt(n[0], 0, 6);
        Table.setValueAt(n[1], 1, 6);
        Table.setValueAt(n[2], 2, 6);
        if (n[3] < 15 && n[3] > 0) { //Dont display anthing if n has some insane value, like in case that 7F6 data is not provided
            Table.setValueAt(n[3], 3, 6);
        }

        //Calculate JO-Parameters and Radiative Transition Probabilities
        for (int i = 1; i < 4; i++) {
            AoA[i] = A[i] / A[0];
            if (radioButtonCounts.isSelected()){  //v^3 for counts, v^4 for W
                vov[i] = pow(v[0]/v[i],3);
            }
            else {
                vov[i] = pow(v[0]/v[i],4);
            }
            Om[i] = 0.0372971 * vov[i] * pow(n[0], 3) * AoA[i] / (U[i] * n[i] * pow(pow(n[i], 2) + 2, 2)); //x10^20
            Table.setValueAt(Math.round(Om[i]*1000.0)/1000.0, i, 3);
            // Radiative Transition Probabilities
            RT[i] = pow(v[i], 3) * n[i] * pow(pow(n[i], 2) + 2, 2) * 8.03877 * pow(10, -11) * Om[i] * U[i];
            Table.setValueAt(Math.round(RT[i]*1000.0)/1000.0, i, 4);
        }
        RT[0] = 2.99823 * pow(10, -12) * pow(v[0], 3) * pow(n[0], 3); //for MD transition
        Table.setValueAt(Math.round(RT[0]*1000.0)/1000.0, 0, 4);

        //Set to 0 any NaN RT
        for (int i = 0; i < 4; i++) {
            if (Double.isNaN(RT[i])) {
                RT[i] = 0;
            }
        }


// Radiative lifetime
        double TotalA = A[0] + A[1] + A[2] + A[3];
        AR = RT[0] + RT[1] + RT[2] + RT[3];
        tauRadCalc = 1 / AR;
        tauRadTh = pow(n[0], -3) * A[0] / (14.65 * TotalA);
        //From observable lifetime
        try {
            tauObs = Double.parseDouble(tauObsTextField.getText()); //must be entered in s
            if (tauObs > 0) {
                ANR = 1 / tauObs - AR;
                //P = sigma * tauObs;
                eta = tauObs / tauRadCalc;
            }
        } catch (NumberFormatException e) {
            //Just ignore
        }
        //From Overall Quantum Yield
        if (tauObs > 0) {
            try {
                Phi = Double.parseDouble(PhiTextField.getText());
                etaSens = Phi / eta;
            } catch (NumberFormatException e) {
                //Ignore error
            }
        }

// Branching Ratios
        for (int i = 0; i < 4; i++) {
            BR[i] = A[i] / TotalA; //Exp Branching Ratios
            BR2[i] = RT[i] / AR;// Th Branching Ratios
            Table.setValueAt(BR[i], i, 5);
        }
//Cross section
        sigma = CalculateCrossSection();

        //Asymmetric Ratio (must be in nm)
        try {
            asymmetricRatio = A[1] / A[0];
        } catch (NumberFormatException e) {
            //Ignore
        }
        asymmetricRatio = Math.round(asymmetricRatio * 1000.0) / 1000.0;
        asymmetricRatioLabel.setText(Double.toString(asymmetricRatio));

        //End Calculate
    }//GEN-LAST:event_CalculateButtonActionPerformed

    private void createReportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createReportActionPerformed
        String newLine = System.getProperty("line.separator");//This will retrieve line separator dependent on OS
        //txt file contents
        String[] report = new String[53];
        String reportTotal = "";
        if (refractiveIndexSelection.getSelectedIndex() == 0) { //First value is user defined
            report[0] = "<h1>Judd-Ofelt from Emission Spectra of Eu<sup>3+</sup></h1>";
        } else {
            report[0] = "<h1>Judd-Ofelt from Emission Spectra of Eu<sup>3+</sup> incorporated in " + String.valueOf(refractiveIndexSelection.getSelectedItem()) + "</h1>";
        }
        report[1] = "<br />";
        report[2] = "<h1>Peaks:</h1>";
        report[3] = "<ul><li><sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>: Integrated from " + String.valueOf(Table.getValueAt(0, 0)) + " nm to " + String.valueOf(Table.getValueAt(0, 1)) + " nm, Area = " + String.valueOf(Table.getValueAt(0, 2)) + "</li>";
        report[4] = "<li><sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>: Integrated from " + String.valueOf(Table.getValueAt(1, 0)) + " nm to " + String.valueOf(Table.getValueAt(1, 1)) + " nm, Area = " + String.valueOf(Table.getValueAt(1, 2)) + "</li>";
        report[5] = "<li><sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>: Integrated from " + String.valueOf(Table.getValueAt(2, 0)) + " nm to " + String.valueOf(Table.getValueAt(2, 1)) + " nm, Area = " + String.valueOf(Table.getValueAt(2, 2)) + "</li>";
        report[6] = "<li><sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>: Integrated from " + String.valueOf(Table.getValueAt(3, 0)) + " nm to " + String.valueOf(Table.getValueAt(3, 1)) + " nm, Area = " + String.valueOf(Table.getValueAt(3, 2)) + "</li>";
        report[7] = "</ul>";
        report[8] = "<br />";
        report[9] = "<h1>";
        report[10] = "Refractive indexes</h1>";
        report[11] = "<ul><li>n(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>) = " + String.valueOf(n[0]) + "</li>";
        report[12] = "<li>n(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>) = " + String.valueOf(n[1]) + "</li>";
        report[13] = "<li>n(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>) = " + String.valueOf(n[2]) + "</li>";
        report[14] = "<li>n(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>) = " + String.valueOf(n[3]) + "</li>";
        report[15] = "</ul><br />";
        report[16] = "<h1>Judd-Ofelt Parameters:</h1><ul>";
        report[17] = "<li>Ω<sub>2</sub> = " + String.valueOf(Table.getValueAt(1, 3)) + " x 10<sup>-20</sup> cm²</li>";
        report[18] = "<li>Ω<sub>4</sub> = " + String.valueOf(Table.getValueAt(2, 3)) + " x 10<sup>-20</sup> cm²</li>";
        if (String.valueOf(Table.getValueAt(3, 3)) != null){
            report[19] = "<li>Ω<sub>6</sub> = " + String.valueOf(Table.getValueAt(3, 3)) + " x 10<sup>-20</sup> cm²</li></ul>";
        }
        else {
            report[19] = "";
        }
        report[20] = "<br />";
        report[21] = "<h1>== Derived Quantities ==</h1>";
        report[22] = "<h2>Radiative Transition Probabilities</h2>";
        report[23] = "<ul><li>A(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>) = " + String.valueOf(Table.getValueAt(0, 4)) + " s<sup>-1</sup></li>";
        report[24] = "<li>A(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>) = " + String.valueOf(Table.getValueAt(1, 4)) + " s<sup>-1</sup></li>";
        report[25] = "<li>A(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>) = " + String.valueOf(Table.getValueAt(2, 4)) + " s<sup>-1</sup></li>";
        report[26] = "<li>A(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>) = " + String.valueOf(Table.getValueAt(3, 4)) + " s<sup>-1</sup></li></ul>";
        report[27] = "<br />";
        report[28] = "<h2>Experimental Branching Ratios and Theoretical Branching Ratios</h2>";
        report[29] = "<ul><li>β(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>) = " + String.valueOf(Table.getValueAt(0, 5)) + "; " + String.valueOf(BR2[0]) + "</li>";
        report[30] = "<li>β(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>) = " + String.valueOf(Table.getValueAt(1, 5)) + "; " + String.valueOf(BR2[1]) + "</li>";
        report[31] = "<li>β(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>) = " + String.valueOf(Table.getValueAt(2, 5)) + "; " + String.valueOf(BR2[2]) + "</li>";
        report[32] = "<li>β(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>) = " + String.valueOf(Table.getValueAt(3, 5)) + "; " + String.valueOf(BR2[3]) + "</li>";
        report[33] = "</ul><br />";
        report[34] = "<h2>Barycenters</h2>";
        report[35] = "<ul><li>v(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>) = " + String.valueOf(v[0]) + " cm<sup>-1</sup>" + "</li>";
        report[36] = "<li>v(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>) = " + String.valueOf(v[1]) + " cm<sup>-1</sup>" + "</li>";
        report[37] = "<li>v(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>) = " + String.valueOf(v[2]) + " cm<sup>-1</sup>" + "</li>";
        report[38] = "<li>v(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>) = " + String.valueOf(v[3]) + " cm<sup>-1</sup>" + "</li>";
        report[39] = "</ul><br />";
        report[40] = "Total Radiative transition probability = " + String.valueOf(AR) + " s<sup>-1</sup><br />";
        report[41] = "Nonradiative transition probability = " + String.valueOf(ANR) + " s<sup>-1</sup>";
        report[42] = "<br />";
        report[43] = "<h2>Lifetimes</h2>";
        report[44] = "<ul><li>Theoretical radiative lifetime = " + String.valueOf(tauRadTh) + " s" + "</li>";
        report[45] = "<li>Calculated radiative lifetime = " + String.valueOf(tauRadCalc) + " s" + "</li>";
        report[46] = "</ul><br /><h2>Cross-sections</h2>";
        report[47] = "<ul><li>σ(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>1</sub>) = " + String.valueOf(sigma[0]) + " cm²" + "</li>";
        report[48] = "<li>σ(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>2</sub>) = " + String.valueOf(sigma[1]) + " cm²" + "</li>";
        report[49] = "<li>σ(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>4</sub>) = " + String.valueOf(sigma[2]) + " cm²" + "</li>";
        report[50] = "<li>σ(<sup>5</sup>D<sub>0</sub>→<sup>7</sup>F<sub>6</sub>) = " + String.valueOf(sigma[3]) + " cm²" + "</li></ul></br>";
        report[51] = "PL Quantum efficiency = " + String.valueOf(eta);
        report[52] = "<br />Sensitization efficiency = " + String.valueOf(etaSens);
        for (int i = 0; i <= 52; i++) {
            reportTotal = reportTotal + report[i] + newLine;
        }
        //end txt file contents
        JFileChooser fileChooser = new JFileChooser();
        if (fileChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            //System.out.println(": " + file.getAbsolutePath());
            writeTOFile(file, reportTotal, ".html");
        }
    }//GEN-LAST:event_createReportActionPerformed

    private void refractiveIndexSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refractiveIndexSelectionActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_refractiveIndexSelectionActionPerformed

    private void popupWarning(String warningTitle, String warningMessage) {
        JOptionPane optionPane = new NarrowOptionPane();
        optionPane.setMessage(warningMessage);
        optionPane.setMessageType(JOptionPane.WARNING_MESSAGE);
        JDialog dialog = optionPane.createDialog(null, warningTitle);
        dialog.setVisible(true);
    }

    private void aboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutActionPerformed
        String msg = "JOES v4.0\nThe application for calculation of Judd-Ofelt intensity parameters and derived quantities\nfrom the Emission spectra of Eu3+\nAuthor: Aleksandar Ciric\nemail: aleksandar.ciric@ff.bg.ac.rs\nSupervisor: prof. Miroslav Dramicanin\nVinca Institute of Nuclear Sciences, Belgrade\nUniversity of Belgrade\nThe software is under GPLv3 license";
        JOptionPane optionPane = new NarrowOptionPane();
        optionPane.setMessage(msg);
        optionPane.setMessageType(JOptionPane.INFORMATION_MESSAGE);
        JDialog dialog = optionPane.createDialog(null, "About " + title2);
        dialog.setVisible(true);
    }//GEN-LAST:event_aboutActionPerformed

    private void helpContentsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpContentsActionPerformed
        File f = new File("help.pdf");
        try {
            Desktop.getDesktop().browse(f.toURI());
        } catch (IOException ex) {
            Logger.getLogger(JOES_UI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_helpContentsActionPerformed

    private void saveConfigurationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveConfigurationActionPerformed
        String newLine = System.getProperty("line.separator"); //This will retrieve line separator dependent on OS
        String dataToSave = "";
        //Data to write
        for (int j = 0; j < Table.getColumnCount(); j++) {
            for (int i = 0; i < Table.getRowCount(); i++) {
                dataToSave = dataToSave + String.valueOf(Table.getValueAt(i, j)) + newLine;
            }
        }

        dataToSave = dataToSave + refractiveIndexSelection.getSelectedIndex();

        //Write to joes file
        JFileChooser fileChooser = new JFileChooser();
        if (fileChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            writeTOFile(file, dataToSave, ".joes");
        }
    }//GEN-LAST:event_saveConfigurationActionPerformed

    private void loadConfigurationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadConfigurationActionPerformed
        //Open file and parse to array
        int k = 0;
        //Load line by line and store into array
        String[] dataLoadedString = new String[46];
        int returnVal = FileChooserjoes.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = FileChooserjoes.getSelectedFile();
            try (BufferedReader br = new BufferedReader(new FileReader(file))) {
                for (int t = 0; t < 46; t++) {
                    dataLoadedString[t] = br.readLine();
                }
            } catch (IOException ex) {
                System.out.println("problem accessing file" + file.getAbsolutePath());
            }
        } else {
            System.out.println("File access cancelled by user.");
        }
        //Now write it to the table and set variables
        for (int j = 0; j < Table.getColumnCount(); j++) {
            for (int i = 0; i < Table.getRowCount(); i++) {
                if ("null".equals(dataLoadedString[k])) {
                    k++;
                } else {
                    Table.setValueAt(Double.parseDouble(dataLoadedString[k]), i, j);
                    k++;
                }
            }
        }
        refractiveIndexSelection.setSelectedIndex(Integer.parseInt(dataLoadedString[k]));
    }//GEN-LAST:event_loadConfigurationActionPerformed

    private void symmetrySet() {
        numberOfBands[0] = jComboBox7F0.getSelectedIndex();
        numberOfBands[1] = jComboBox7F1.getSelectedIndex();
        numberOfBands[2] = jComboBox7F2.getSelectedIndex();
        numberOfBands[3] = jComboBox7F3.getSelectedIndex();
        numberOfBands[4] = jComboBox7F4.getSelectedIndex();
        int BandsTotal = numberOfBands[0] * 10000 + numberOfBands[1] * 1000 + numberOfBands[2] * 100 + numberOfBands[3] * 10 + numberOfBands[4];
        int Bands[] = {1000, 1011, 1111, 1122, 2000, 2012, 2121, 2123, 2133, 2233, 2244, 2344, 3000, 3366, 12222, 12224, 12235, 12335, 12356, 13457, 13579};
        String BandsNames[] = {"T<sub>h</sub>, O<sub>h</sub>, I<sub>h</sub>", "O", "T<sub>d</sub>", "T", "C<sub>3i</sub>, D<sub>3d</sub>, C<sub>4h</sub>, D<sub>4h</sub>, C<sub>6h</sub>, D<sub>6h</sub>", "D<sub>4d</sub>", "D<sub>6</sub>", "D<sub>3h</sub>", "D<sub>4</sub>", "D<sub>2d</sub>", "D<sub>3</sub>", "S<sub>4</sub>", "C<sub>i</sub>, C<sub>2h</sub>, D<sub>2h</sub>", "D<sub>2</sub>", "C<sub>6</sub>, C<sub>6v</sub>", "C<sub>4v</sub>", "C<sub>4</sub>", "C<sub>3v</sub>", "C<sub>3</sub>", "C<sub>2v</sub>", "C<sub>1</sub>, C<sub>s</sub>, C<sub>2</sub>", "N/A"};
        int BandsMatchIndex = 21;
        //System.out.println(BandsTotal);
        for (int w = 0; w <= 20; w++) {
            //System.out.println(BandsNames[w] + ", " + Bands[w]);
            if (Bands[w] == BandsTotal) {
                BandsMatchIndex = w;
            }
        }
        //System.out.println(BandsMatchIndex);
        pointGroupSymmetryLabel.setText("<html>" + BandsNames[BandsMatchIndex] + "</html>");
    }

    private void jComboBox7F0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7F0ActionPerformed
        symmetrySet();
    }//GEN-LAST:event_jComboBox7F0ActionPerformed

    private void jComboBox7F1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7F1ActionPerformed
        symmetrySet();
    }//GEN-LAST:event_jComboBox7F1ActionPerformed

    private void jComboBox7F2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7F2ActionPerformed
        symmetrySet();
    }//GEN-LAST:event_jComboBox7F2ActionPerformed

    private void jComboBox7F3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7F3ActionPerformed
        symmetrySet();
    }//GEN-LAST:event_jComboBox7F3ActionPerformed

    private void jComboBox7F4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7F4ActionPerformed
        symmetrySet();
    }//GEN-LAST:event_jComboBox7F4ActionPerformed

    private void radioButtonWActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonWActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_radioButtonWActionPerformed

    private void checkboxNanoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkboxNanoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_checkboxNanoActionPerformed

    private void fillingFactorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fillingFactorActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fillingFactorActionPerformed

    private void tauObsTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tauObsTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_tauObsTextFieldActionPerformed

    private void radioButtonCountsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonCountsActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_radioButtonCountsActionPerformed

    private void PhiTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PhiTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_PhiTextFieldActionPerformed

    private void RemoveBackgroundActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveBackgroundActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_RemoveBackgroundActionPerformed

    public double yLmaxCalculate() { //Calculates spectra's maximum
        double yLmax = 0;
        for (int i = 1; i < m; i++) {
            if (yL[i] > yLmax) {
                yLmax = yL[i];
            }
        }
        return yLmax;
    }

    private void drawSpectra() {
        // ((PPanel)drawingPanel).brisi();

        Graphics2D gfx = (Graphics2D) drawingPanel.getGraphics();
        gfx.clearRect(0, 0, drawingPanel.getWidth(), drawingPanel.getHeight());
        //drawingPanel.paintComponents(gfx);
        //Draw coordinate axis
        gfx.drawLine(20, 220, 470, 220); //x-axis
        gfx.drawLine(20, 10, 20, 220); //y-axis
        // Draw triangles for Arrows
        int x1arrow[] = {20, 26, 14};
        int y1arrow[] = {6, 12, 12};
        gfx.fillPolygon(x1arrow, y1arrow, 3);
        int x2arrow[] = {472, 466, 466};
        int y2arrow[] = {220, 226, 214};
        gfx.fillPolygon(x2arrow, y2arrow, 3);
        //Draw ticks
        for (int i = 0; i < 45; i++) {
            gfx.drawLine(20 + i * 10, 220, 20 + i * 10, 225); //minor ticks for x-axis
        }
        for (int i = 0; i < 20; i++) {
            gfx.drawLine(20, 220 - i * 10, 15, 220 - i * 10); //minor ticks for y-axis
        }
        for (int i = 0; i < 9; i++) {
            gfx.drawLine(20 + i * 50, 220, 20 + i * 50, 230); //major ticks for x-axis
            gfx.drawString(Integer.toString(i * 50 + 450), 10 + i * 50, 242);
        }
        for (int i = 1; i <= 4; i++) {
            gfx.drawLine(20, 220 - i * 50, 10, 220 - i * 50); //major ticks for y-axis
        }
        //Draw x and y labels
        gfx.drawString("I", 5, 15);
        gfx.drawString("λ", 466, 242);

        //Draw spectra
        double xLmax = 450.0;
        double yLmax = 0;
        yLmax = yLmaxCalculate();
        GeneralPath spectra = new GeneralPath(GeneralPath.WIND_EVEN_ODD, m);
        //spectra.moveTo((int) xL[0] - 450 + 20, -2 * (int) (yL[0] * 100 / yLmax) + 220);       
        spectra.moveTo(20, 220);
        for (int index = 1; index < m - 2; index++) {
            if (xL[index] > 450) { //Limit the wavelenght drawing
                spectra.lineTo((int) xL[index] - 450 + 20, -2 * (int) (yL[index] * 100 / yLmax) + 220);
            }
            //Find xLmax
            if (yL[index] == yLmax) {
                xLmax = xL[index];
            }
        }
        //Draw spectra
        gfx.setColor(Color.BLUE);
        gfx.setStroke(new BasicStroke(2f));
        gfx.draw(spectra);

        //Draw maxima line
        float[] dashingPattern1 = {2f, 2f};
        Stroke stroke1 = new BasicStroke(2f, BasicStroke.CAP_BUTT,
                BasicStroke.JOIN_MITER, 1.0f, dashingPattern1, 2.0f);
        gfx.setColor(Color.RED);
        gfx.setStroke(stroke1);
        gfx.drawLine((int) xLmax - 450 + 20, 220, (int) xLmax - 450 + 20, 10); //Draw max line

    }

    class NarrowOptionPane extends JOptionPane {

        NarrowOptionPane() {
        }

        public int getMaxCharactersPerLineCount() {
            return 100;
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;

                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JOES_UI.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JOES_UI.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JOES_UI.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);

        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JOES_UI.class
                    .getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JOES_UI().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CalculateButton;
    private javax.swing.JMenuItem Exit;
    private javax.swing.JFileChooser FileChooserjoes;
    private javax.swing.JMenuItem ImportDatabase;
    private javax.swing.JTextField PhiTextField;
    private javax.swing.ButtonGroup RefractiveIndexChoiceRadioGroup;
    private javax.swing.JCheckBox RemoveBackground;
    private javax.swing.ButtonGroup SpectraUnitbuttonGroup1;
    private javax.swing.JTable Table;
    private javax.swing.JTextArea TextArea;
    private javax.swing.JMenuItem about;
    private javax.swing.JLabel asymmetricRatioLabel;
    private javax.swing.JCheckBox checkboxNano;
    private javax.swing.JMenuItem createReport;
    private javax.swing.JPanel drawingPanel;
    private javax.swing.JFileChooser fileChoosertxt;
    private javax.swing.JTextField fillingFactor;
    private javax.swing.JMenuItem helpContents;
    private javax.swing.JComboBox<String> jComboBox7F0;
    private javax.swing.JComboBox<String> jComboBox7F1;
    private javax.swing.JComboBox<String> jComboBox7F2;
    private javax.swing.JComboBox<String> jComboBox7F3;
    private javax.swing.JComboBox<String> jComboBox7F4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JMenuItem loadConfiguration;
    private javax.swing.JTextField nmed;
    private javax.swing.JLabel pointGroupSymmetryLabel;
    private javax.swing.JRadioButton radioButtonCounts;
    private javax.swing.JRadioButton radioButtonW;
    private javax.swing.JComboBox<String> refractiveIndexSelection;
    private javax.swing.JMenuItem saveConfiguration;
    private javax.swing.JTextField tauObsTextField;
    // End of variables declaration//GEN-END:variables

    private void writeTOFile(File file, String ehej, String ext) {
        if (file.exists()) {
            file.delete();
        }
        Path path = null;
        try {
            path = Paths.get(file.getCanonicalPath() + ext);
        } catch (IOException ex) {
            Logger.getLogger(JOES_UI.class.getName()).log(Level.SEVERE, null, ex);
        }
        try (BufferedWriter writer = Files.newBufferedWriter(path, StandardCharsets.UTF_8)) {
            writer.write(ehej);
        } catch (IOException ex) {
            Logger.getLogger(JOES_UI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
